mod Maux logic: 'cl'

incl Mtex

incl Mtexnt

rem 
  \para \bf  Lists.  \end 

rem 
  \para \it  List indexing.  \end 

appldisp/2 Tex_f2_ln_sub
  Prefix(70,2,Arg(0),Fenced(Op('[',0),Arg(1),Op(']',0)))

fun/2 Sub 'Tex_f2_ln_sub'
  Sub(x,0) = v <- x = v,w
  Sub(x,i+1) = Sub(w,i) <- x = v,w

rem 
  \para \bf  Numeric terms.  \end 

rem 
  \para \it  Arithmetization.  \end 

fun Vt 'Tex_f1_nt_vt'
  Vt(i) = 0,i

fun Ct 'Tex_f1_nt_ct'
  Ct(n) = 1,n

fun/2 At 'Tex_f2_nt_at'
  At(t1,t2) = 2,t1,t2

fun/2 Mt 'Tex_f2_nt_mt'
  Mt(t1,t2) = 3,t1,t2

pred Term 
  Term Vt(i) <- N(i)
  Term Ct(n) <- N(n)
  Term At(t1,t2) <- Term(t1) & Term(t2)
  Term Mt(t1,t2) <- Term(t1) & Term(t2)

rem 
  \para \it  Denotation.  \end 

fun/2 Den 'Tex_f2_nt_den'
  Den(Vt(i),v) = Sub(v,i)
  Den(Ct(n),v) = n
  Den(At(t1,t2),v) = Den(t1,v)+Den(t2,v)
  Den(Mt(t1,t2),v) = Den(t1,v)*Den(t2,v)

rem 
  \para \bf  Postfix machine.  \end 

rem 
  \para \it  Instructions.  \end 

fun Vi 'Tex_f1_nt_vi'
  Vi(i) = 0,i

fun Ci 'Tex_f1_nt_ci'
  Ci(n) = 1,n

fun/0 Ai 'Tex_f0_nt_ai'
  Ai = 2,0

fun/0 Mi 'Tex_f0_nt_mi'
  Mi = 3,0

pred Instr 
  Instr Vi(i) <- N(i)
  Instr Ci(n) <- N(n)
  Instr(Ai)
  Instr(Mi)

rem 
  \para \it  Compilation.  \end 

fun Cmp 
  Cmp Vt(i) = Vi(i),0
  Cmp Ct(n) = Ci(n),0
  Cmp At(t1,t2) = Cmp(t1)++Cmp(t2)++(Ai,0)
  Cmp Mt(t1,t2) = Cmp(t1)++Cmp(t2)++(Mi,0)

